var execute = require('child_process').exec;
var prettyjson = require('prettyjson');

exports.index = function(req, res){
    console.log("Client connected: " + req.ip);
    res.render('index', {title: 'PlaceHolderName'});
};

exports.servers = function(req, res){
    console.log("Client " + req.ip + " requesting server list...");
    execute('p4 -ztag -p localhost:1666 -u jrobinson servers', function(error, stdout, stderr){
        if(error){
            res.send("ERROR: " + error);
        }
        
        var servers = {};
        
        var currentID = "";
        var currentServer;
        
        var lines = stdout.split('\n');
        for(line in lines){
        
            var key = (/\b\w*\b/).exec(lines[line]);
            if(key == null){
                continue;
            }
            
            var value = lines[line].substring(key.index + key[0].length + 1);
            
            if(key == 'ServerID'){
                currentServer = value;
                servers[currentServer] = {
                    attr: {}
                };
                continue;
            }
            servers[currentServer].attr[key[0]] = value;
        }
        
        console.log(prettyjson.render(servers));
        res.json(servers);
    });
};

exports.p4vars = function(req, res){
    res.json(p4Vars);
}

exports.login = function(req, res){
    console.log("Client " + req.ip + " logging in...");
    var address = req.body.address,
        username = req.body.username,
        password = req.body.password;

    console.log("Client " + req.ip + " logging in to: " + address);
    
    res.redirect('index', {title: 'PlaceHolderName'});
}